# -*- coding: UTF-8 -*-

from artix.common import logger
from nes_common import nesconfig
import os


defaultLoggerConf = {
    'version': 1,
    'loggers': {
        '': {  # root logger
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadService': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadShop': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadcash': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        }
    },
    'handlers': {
        'nesHandler': {
            'level': 'DEBUG',
            'formatter': 'nesUploadServiceFormatter',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/tmp/nes.log',
            'mode': 'a',
            'maxBytes': 100000000,
            'backupCount': 10
        }
    },
    'formatters': {
        'nesUploadServiceFormatter': {
            'format': '%(asctime)s %(thread)d %(levelname)-8s %(message)s %(module)5s(%(lineno)s)'
        }
    }
}


def getLogger(name, fileName=None):
    name = 'nesUpload' + name
    fileName = os.path.join(nesconfig.getString('MAIN', 'logDirectory', '/tmp'),
            (('nesUpload' + fileName) if fileName else name) + '.log')
    errorsFilePath = nesconfig.getString('MAIN', 'errorsFilePath', None) if nesconfig.isCash() else None
    return logger.SimpleLogger(fileName, name,
            configPath=os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/logging.properties'),
            dictConfigObject=defaultLoggerConf, errorsFilePath=errorsFilePath).getLogger()
